package jcg.zheng.demo.bst;

public class BSTCRDService {

    public BinaryTreeNode add(BinaryTreeNode current, int addingValue) {
        if (current == null) {
            return new BinaryTreeNode(addingValue);
        }

        if (addingValue < current.getKeyValue()) {
            current.setLeft(add(current.getLeft(), addingValue));
        } else if (addingValue == current.getKeyValue()) {
            return current;
        } else {
            current.setRight(add(current.getRight(), addingValue));
        }

        return current;
    }

    public BinaryTreeNode delete(BinaryTreeNode current, int deletingValue) {
        if (current == null) {
            return null;
        }

        if (deletingValue == current.getKeyValue()) {
            if (current.getLeft() == null) {
                if (current.getRight() == null) {
                    // delete the leaf node
                    return null;
                } else {
                    // only right child
                    return current.getRight();
                }
            } else {
                if (current.getRight() == null) {
                    // only Left child
                    return current.getLeft();
                } else {
                    // has both children
                    int smallest = findMinValue(current.getRight());
                    current.setKeyValue(smallest);
                    current.setRight(delete(current.getRight(), smallest));

                    return current;
                }

            }
        } else if (deletingValue < current.getKeyValue()) {
            current.setLeft(delete(current.getLeft(), deletingValue));
            return current;
        } else {
            current.setRight(delete(current.getRight(), deletingValue));
            return current;
        }

    }

    public int findMinValue(BinaryTreeNode node) {
        return node.getLeft() == null ? node.getKeyValue() : findMinValue(node.getLeft());
    }

    public BinaryTreeNode searchNode(BinaryTreeNode current, int findingValue) {
        if (current == null) {
            return null;
        }

        if (findingValue == current.getKeyValue()) {
            return current;
        } else if (findingValue > current.getKeyValue()) {
            return searchNode(current.getRight(), findingValue);
        } else {
            return searchNode(current.getLeft(), findingValue);
        }

    }

    public Integer findMaxValue(BinaryTreeNode node) {
        return node.getRight() == null ? node.getKeyValue() : findMaxValue(node.getRight());
    }

}
