package jcg.zheng.demo.bst;

import java.util.LinkedList;
import java.util.Queue;

public class TraverseBSTService {

    private static final String SPACE = " ";

    public void inOrder(BinaryTreeNode rootNode) {
        if (rootNode != null) {
            inOrder(rootNode.getLeft());
            print(rootNode);
            inOrder(rootNode.getRight());
        }

    }

    public void levelOrder(BinaryTreeNode rootNode) {

        if (rootNode == null)
            return;

        Queue<BinaryTreeNode> fifoQueue = new LinkedList<>();

        fifoQueue.add(rootNode);

        while (!fifoQueue.isEmpty()) {
            rootNode = fifoQueue.poll();
            print(rootNode);

            if (rootNode.getLeft() != null) {
                fifoQueue.add(rootNode.getLeft());
            }

            if (rootNode.getRight() != null) {
                fifoQueue.add(rootNode.getRight());
            }
        }

    }

    public void postOrder(BinaryTreeNode rootNode) {
        if (rootNode != null) {
            preOrder(rootNode.getLeft());
            preOrder(rootNode.getRight());
            print(rootNode);
        }
    }

    public void preOrder(BinaryTreeNode rootNode) {
        if (rootNode != null) {
            print(rootNode);
            preOrder(rootNode.getLeft());
            preOrder(rootNode.getRight());
        }

    }

    private void print(BinaryTreeNode rootNode) {
        System.out.print(rootNode.getKeyValue() + SPACE);
    }

}
