package jcg.zheng.demo.bst;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import org.junit.Test;

public class BinarySearchTreeTest extends TestBase {

    @Test
    public void delete_max() {
        BinaryTreeNode existNode = crdService.searchNode(bst.getRoot(), MAX);
        assertNotNull(existNode);

        bst.delete(MAX);

        System.out.println("\nupdated list");
        tService.preOrder(bst.getRoot());

        BinaryTreeNode deletedNode = crdService.searchNode(bst.getRoot(), MAX);
        assertNull(deletedNode);

    }

    @Test
    public void delete_min() {
        BinaryTreeNode existNode = crdService.searchNode(bst.getRoot(), MIN);
        assertNotNull(existNode);

        bst.delete(MIN);

        System.out.println("\nupdated list");
        tService.preOrder(bst.getRoot());

        BinaryTreeNode deletedNode = crdService.searchNode(bst.getRoot(), MIN);
        assertNull(deletedNode);

    }

    @Test
    public void delete_only_left_child() {
        BinaryTreeNode existNode = crdService.searchNode(bst.getRoot(), 3);
        assertNotNull(existNode);

        bst.delete(3);

        System.out.println("\nupdated list");
        tService.preOrder(bst.getRoot());

        BinaryTreeNode deletedNode = crdService.searchNode(bst.getRoot(), 3);
        assertNull(deletedNode);

    }

    @Test
    public void delete_only_right_child() {
        BinaryTreeNode existNode = crdService.searchNode(bst.getRoot(), 9);
        assertNotNull(existNode);

        bst.delete(9);
        System.out.println("\nupdated list");
        tService.preOrder(bst.getRoot());

        BinaryTreeNode deletedNode = crdService.searchNode(bst.getRoot(), 9);
        assertNull(deletedNode);

    }

    @Test
    public void delete_subtreeNode() {
        BinaryTreeNode existNode = crdService.searchNode(bst.getRoot(), 4);
        assertNotNull(existNode);

        bst.delete(4);
        System.out.println("\nupdated list");
        tService.preOrder(bst.getRoot());

        BinaryTreeNode deletedNode = crdService.searchNode(bst.getRoot(), 4);
        assertNull(deletedNode);

    }

    @Test
    public void findMin() {
        int minValue = bst.min();
        assertEquals(2, minValue);
    }

    @Test
    public void findMax() {
        int minValue = bst.max();
        assertEquals(10, minValue);
    }

    @Test
    public void searchNode_found() {
        BinaryTreeNode existNode = crdService.searchNode(bst.getRoot(), 4);
        assertNotNull(existNode);
        assertEquals(4, existNode.getKeyValue());
        assertNotNull(existNode.getLeft());

        assertNotNull(existNode.getRight());
    }

    @Test
    public void searchNode_not_found() {
        BinaryTreeNode notexistNode = crdService.searchNode(bst.getRoot(), 11);
        assertNull(notexistNode);
    }

}
