package jcg.zheng.demo.bst;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.TreeSet;

import org.junit.Test;

public class JDKLibraryTest {

    @Test
    public void TreeSet_is_same_as_BST_inOrder() {
        // TreeSet from JDK is basically implementation of a self-balancing binary search tree.
        // like Red-Black Tree, the add, remove, search take O(log n) time.
        TreeSet<Integer> ts = new TreeSet<>();

        ts.add(Integer.valueOf(6));
        ts.add(Integer.valueOf(4));
        ts.add(Integer.valueOf(8));
        ts.add(Integer.valueOf(3));
        ts.add(Integer.valueOf(5));
        ts.add(Integer.valueOf(7));
        ts.add(Integer.valueOf(9));
        ts.add(Integer.valueOf(2));
        ts.add(Integer.valueOf(10));
        System.out.println("should print out 2345678910");
        ts.forEach(bst -> System.out.print(bst)); // 2345678910

        boolean foundThree = ts.contains(Integer.valueOf(3));
        assertTrue(foundThree);
    }

    @Test
    public void collections_binarySearch() {
        List<Integer> testList = new ArrayList<>();
        for (int i = 10; i < 20; i++) {
            testList.add(Integer.valueOf(i));
        }

        int foundIndex = Collections.binarySearch(testList, 13);
        assertEquals(3, foundIndex);
    }

}
